#!/usr/bin/env python
# vim: set ff=unix expandtab: shiftwidth=4 fileencoding=utf-8
"""
Intelligent RObotics 2014 - source code skeleton
(c) 2014 Czech Technical University, Faculty of Electrical Engineering, Department of Cybernetics

TASK 1
======

This is the sample source code for task 1. Students are free to change it in order to solve the task.

Other use is allowed under the terms of the New BSD license.
"""
__author__ =  'Martin Pecka <peckama2 fel.cvut.cz>'
__version__=  '2014.1.1'
__license__ = 'BSD'

# Ros libraries
import roslib; roslib.load_manifest('task1')
import rospy;

# Python libs
import sys, os

# numpy, scipy and pylab
import numpy as np
from scipy.io import loadmat
from pylab import imshow,show

class reprojection_viewer:
    '''A helper node that visualizes the computed projection matrix results'''

    def __init__(self):
        '''Load the saved .mat files.'''

        base_path = os.path.dirname(os.path.realpath(__file__))
        thermo_data = loadmat(base_path + '/../data/thermo_images.mat')
        rgb_data = loadmat(base_path + '/../data/rgb_images.mat')
        depth_data = loadmat(base_path + '/../data/depth_images.mat')
        kinect_K_data = loadmat(base_path + '/../data/kinect_K.mat')
        P_denormalized_data = loadmat(base_path + '/../data/P_denormalized.mat')


        self.depth_images = depth_data['depth_images']
        self.rgb_images = rgb_data['rgb_images']
        self.thermo_images = thermo_data['thermo_images']
        self.kinect_K = np.matrix(kinect_K_data['kinect_K'], np.float32)
        self.P_denormalized = P_denormalized_data['P_denormalized']

    def main_loop(self):

        max_temperature = 100.0
        for image_index in range(len(self.depth_images)):
            if rospy.is_shutdown():
                break

            print 'Displaying image', image_index

            image_index = 0;
            image = self.rgb_images[image_index]
            depth_image = self.depth_images[image_index]
            thermo_image = self.thermo_images[image_index]

            # IMPLEMENT (optional)
            # implement the reprojection code which alters the image variable in such way that all points hot in thermocam will be highlighted in image
            # since you can't devise the depth of a thermocam point, you have to fake the projection a little bit and start with the known 3D points doing projections both in thermocam and kinect and then somehow process the projections
            

            imshow(image)
            show()

def main(args):
    # initialize and run ROS node
    node = reprojection_viewer()
    rospy.init_node('reprojection_viewer', anonymous=True)

    # run the main loop
    node.main_loop()

if __name__ == '__main__':
    main(sys.argv)
